diff --git a/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
index 2b790b8cb5985ff7a590425e7efebeb6512fa30f..e8adc9b2a051baaa2d1009ba31785c25f60bc6a5 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileService.java
@@ -18,27 +18,49 @@
 
 package com.netscape.cms.servlet.profile;
 
+import java.io.File;
+import java.io.IOException;
+import java.net.URI;
+import java.security.Principal;
 import java.util.ArrayList;
 import java.util.Enumeration;
+import java.util.LinkedHashMap;
 import java.util.List;
-import java.util.Locale;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.Vector;
 
-import javax.ws.rs.Path;
+import javax.ws.rs.PathParam;
 import javax.ws.rs.core.UriBuilder;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
+import com.netscape.certsrv.base.IConfigStore;
+import com.netscape.certsrv.common.NameValuePairs;
 import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.profile.IProfileEx;
 import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.certsrv.profile.IProfileOutput;
+import com.netscape.certsrv.profile.IProfilePolicy;
 import com.netscape.certsrv.profile.IProfileSubsystem;
+import com.netscape.certsrv.profile.PolicyConstraint;
+import com.netscape.certsrv.profile.PolicyConstraintValue;
+import com.netscape.certsrv.profile.PolicyDefault;
 import com.netscape.certsrv.profile.ProfileData;
 import com.netscape.certsrv.profile.ProfileDataInfo;
 import com.netscape.certsrv.profile.ProfileDataInfos;
 import com.netscape.certsrv.profile.ProfileInput;
 import com.netscape.certsrv.profile.ProfileNotFoundException;
+import com.netscape.certsrv.profile.ProfileOutput;
+import com.netscape.certsrv.profile.ProfileParameter;
+import com.netscape.certsrv.profile.ProfilePolicy;
 import com.netscape.certsrv.profile.ProfileResource;
+import com.netscape.certsrv.property.EPropertyException;
+import com.netscape.certsrv.registry.IPluginInfo;
+import com.netscape.certsrv.registry.IPluginRegistry;
 import com.netscape.cms.servlet.base.PKIService;
+import com.netscape.cmscore.realm.PKIPrincipal;
 
 /**
  * @author alee
@@ -47,22 +69,31 @@ import com.netscape.cms.servlet.base.PKIService;
 public class ProfileService extends PKIService implements ProfileResource {
 
     private IProfileSubsystem ps = (IProfileSubsystem) CMS.getSubsystem(IProfileSubsystem.ID);
+    private IPluginRegistry registry = (IPluginRegistry) CMS.getSubsystem(CMS.SUBSYSTEM_REGISTRY);
+    private IConfigStore cs = CMS.getConfigStore().getSubStore("profile");
 
     public ProfileDataInfos listProfiles() {
         List<ProfileDataInfo> list = new ArrayList<ProfileDataInfo>();
         ProfileDataInfos infos = new ProfileDataInfos();
+        boolean visibleOnly = true;
 
         if (ps == null) {
             return null;
         }
 
+        PKIPrincipal principal = (PKIPrincipal)servletRequest.getUserPrincipal();
+        if ((principal != null) &&
+            (principal.hasRole("Certificate Manager Agents") ||
+             principal.hasRole("Certificate Manager Administrators"))) {
+            visibleOnly = false;
+        }
         Enumeration<String> profileIds = ps.getProfileIds();
         if (profileIds != null) {
             while (profileIds.hasMoreElements()) {
                 String id = profileIds.nextElement();
                 ProfileDataInfo info = null;
                 try {
-                    info = createProfileDataInfo(id);
+                    info = createProfileDataInfo(id, visibleOnly);
                 } catch (EBaseException e) {
                     continue;
                 }
@@ -79,11 +110,19 @@ public class ProfileService extends PKIService implements ProfileResource {
 
     public ProfileData retrieveProfile(String profileId) throws ProfileNotFoundException {
         ProfileData data = null;
+        boolean visibleOnly = false;
 
         if (ps == null) {
             return null;
         }
 
+        PKIPrincipal principal = (PKIPrincipal)servletRequest.getUserPrincipal();
+        if ((principal != null) &&
+            (principal.hasRole("Certificate Manager Agents") ||
+             principal.hasRole("Certificate Manager Administrators"))) {
+            visibleOnly = true;
+        }
+
         Enumeration<String> profileIds = ps.getProfileIds();
 
         IProfile profile = null;
@@ -108,6 +147,10 @@ public class ProfileService extends PKIService implements ProfileResource {
             throw new ProfileNotFoundException(profileId);
         }
 
+        if (visibleOnly && !profile.isVisible()) {
+            throw new ProfileNotFoundException(profileId);
+        }
+
         try {
             data = createProfileData(profileId);
         } catch (EBaseException e) {
@@ -131,22 +174,21 @@ public class ProfileService extends PKIService implements ProfileResource {
 
         ProfileData data = new ProfileData();
 
-        Locale locale = Locale.getDefault();
-        String name = profile.getName(locale);
-        String desc = profile.getDescription(locale);
-
-        data.setName(name);
-        data.setDescription(desc);
-        data.setIsEnabled(ps.isProfileEnable(profileId));
-        data.setIsVisible(profile.isVisible());
+        data.setAuthenticatorId(profile.getAuthenticatorId());
+        data.setAuthzAcl(profile.getAuthzAcl());
+        data.setClassId(cs.getString(profileId + ".class_id"));
+        data.setDescription(profile.getDescription(getLocale()));
+        data.setEnabled(ps.isProfileEnable(profileId));
         data.setEnabledBy(ps.getProfileEnableBy(profileId));
         data.setId(profileId);
+        data.setName(profile.getName(getLocale()));
+        data.setRenewal(Boolean.getBoolean(profile.isRenewal()));
+        data.setVisible(profile.isVisible());
+        data.setXMLOutput(Boolean.getBoolean(profile.isXmlOutput()));
 
         Enumeration<String> inputIds = profile.getProfileInputIds();
-
-        String inputName = null;
-
         if (inputIds != null) {
+            IConfigStore inputStore = profile.getConfigStore().getSubStore("input");
             while (inputIds.hasMoreElements()) {
                 String inputId = inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
@@ -154,29 +196,65 @@ public class ProfileService extends PKIService implements ProfileResource {
                 if (profileInput == null) {
                     continue;
                 }
-                inputName = profileInput.getName(locale);
 
-                Enumeration<String> inputNames = profileInput.getValueNames();
+                String classId = inputStore.getString(inputId + ".class_id");
 
-                ProfileInput input = data.addProfileInput(inputName);
+                ProfileInput input = new ProfileInput(profileInput, classId, getLocale());
+                data.addProfileInput(inputId, input);
+            }
+        }
 
-                String curInputName = null;
-                while (inputNames.hasMoreElements()) {
-                    curInputName = inputNames.nextElement();
+        // profile outputs
+        Enumeration<String> outputIds = profile.getProfileOutputIds();
+        if (outputIds != null) {
+            IConfigStore outputStore = profile.getConfigStore().getSubStore("output");
+            while (outputIds.hasMoreElements()) {
+                String outputId = outputIds.nextElement();
+                IProfileOutput profileOutput = profile.getProfileOutput(outputId);
 
-                    if (curInputName != null && !curInputName.equals("")) {
-                        input.setInputAttr(curInputName, "");
+                if (profileOutput == null) {
+                    continue;
+                }
+
+                String classId = outputStore.getString(outputId + ".class_id");
+
+                ProfileOutput output = new ProfileOutput(profileOutput, classId, getLocale());
+                data.addProfileOutput(outputId, output);
+            }
+        }
+
+        // profile policies
+        Enumeration<String> policySetIds = profile.getProfilePolicySetIds();
+        if (policySetIds != null) {
+            while (policySetIds.hasMoreElements()) {
+                Vector<ProfilePolicy> pset = new Vector<ProfilePolicy>();
+                String policySetId = policySetIds.nextElement();
+                Enumeration<com.netscape.cms.profile.common.ProfilePolicy> policies =
+                        profile.getProfilePolicies(policySetId);
+                if (policies != null) {
+                    while (policies.hasMoreElements()) {
+                        com.netscape.cms.profile.common.ProfilePolicy policy = policies.nextElement();
+                        IConfigStore policyStore = profile.getConfigStore().getSubStore(
+                                "policyset." + policySetId + "." + policy.getId());
+                        ProfilePolicy p = new ProfilePolicy();
+                        String constraintClassId = policyStore.getString("constraint.class_id");
+                        p.setConstraint(PolicyConstraintFactory.create(getLocale(), policy.getConstraint(), constraintClassId));
+                        String defaultClassId = policyStore.getString("default.class_id");
+                        p.setDef(PolicyDefaultFactory.create(getLocale(), policy.getDefault(), defaultClassId));
+                        p.setId(policy.getId());
+                        pset.add(p);
                     }
-
+                }
+                if (!pset.isEmpty()) {
+                    data.addProfilePolicySet(policySetId, pset);
                 }
             }
         }
 
         return data;
-
     }
 
-    public ProfileDataInfo createProfileDataInfo(String profileId) throws EBaseException {
+    public ProfileDataInfo createProfileDataInfo(String profileId, boolean visibleOnly) throws EBaseException {
 
         if (profileId == null) {
             throw new EBaseException("Error creating ProfileDataInfo.");
@@ -190,16 +268,324 @@ public class ProfileService extends PKIService implements ProfileResource {
             return null;
         }
 
+        if (visibleOnly && !profile.isVisible()) {
+            return null;
+        }
+
         ret = new ProfileDataInfo();
 
         ret.setProfileId(profileId);
 
-        Path profilePath = ProfileResource.class.getAnnotation(Path.class);
-
         UriBuilder profileBuilder = uriInfo.getBaseUriBuilder();
-        profileBuilder.path(profilePath.value() + "/" + profileId);
-        ret.setProfileURL(profileBuilder.build().toString());
+
+        // TODO - fix this once we figure out the auth problem
+        //URI uri = profileBuilder.path(ProfileResource.class).path("{id}").
+        //        build(profileId);
+
+        URI uri = null;
+        if (visibleOnly) {
+            uri = profileBuilder.path(ProfileResource.class).path("profiles").path("{id}")
+                    .build(profileId);
+        } else {
+            uri = profileBuilder.path(ProfileResource.class).path("agent").path("profiles")
+                    .path("{id}").build(profileId);
+        }
+
+        ret.setProfileURL(uri.toString());
 
         return ret;
     }
+
+    public void modifyProfileState(String profileId, String action) {
+        if (ps == null) {
+            // throw internal error exception;
+        }
+
+        Principal principal = servletRequest.getUserPrincipal();
+
+        switch (action) {
+        case "enable":
+            if (ps.isProfileEnable(profileId)) {
+                // throw new ProfileAlreadyEnabled exception
+            }
+            try {
+                ps.enableProfile(profileId, principal.getName());
+            } catch (EProfileException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+            break;
+        case "disable":
+            if (!ps.isProfileEnable(profileId)) {
+                // throw new ProfileAlreadyDisabled exception
+            }
+            String userid = principal.getName();
+            try {
+                if (ps.checkOwner()) {
+                    if (ps.getProfileEnableBy(profileId).equals(userid)) {
+                        ps.disableProfile(profileId);
+                    } else {
+                        // audit log messages
+                        // throw Unauthorized exception
+                    }
+                } else {
+                    ps.disableProfile(profileId);
+                }
+            } catch (EProfileException e) {
+                e.printStackTrace();
+                // throw internal error exception
+            }
+            break;
+        default:
+            // throw Bad Request exception
+        }
+    }
+
+    public void createProfile(ProfileData data){
+        if (ps == null) {
+            // throw internal error exception;
+        }
+
+        IProfile profile = null;
+        String profileId = data.getId();
+        try {
+            profile = ps.getProfile(profileId);
+            if (profile != null) {
+                // throw Profile Already Exists Exception
+            }
+            String config = CMS.getConfigStore().getString("instanceRoot") + "/ca/profiles/ca/" +
+                    profileId + ".cfg";
+            File configFile = new File(config);
+            configFile.createNewFile();
+            IPluginInfo info = registry.getPluginInfo("profile", data.getClassId());
+
+            profile = ps.createProfile(profileId, data.getClassId(), info.getClassName(), config);
+            profile.setName(getLocale(),data.getName());
+            profile.setDescription(getLocale(), data.getDescription());
+            profile.setVisible(data.isVisible());
+            profile.getConfigStore().commit(false);
+            ps.createProfileConfig(profileId, data.getClassId(), config);
+
+            if (profile instanceof IProfileEx) {
+                // populates profile specific plugins such as
+                // policies, inputs and outputs with defaults
+                ((IProfileEx) profile).populate();
+            }
+        } catch (EBaseException | IOException e) {
+            e.printStackTrace();
+            // throw internal error exception
+        }
+
+        changeProfileData(data, profile);
+    }
+
+    public void modifyProfile(String profileId, ProfileData data){
+        if (ps == null) {
+            // throw internal error exception;
+        }
+
+        IProfile profile = null;
+        try {
+            profile = ps.getProfile(profileId);
+            if (profile == null) {
+                // throw ProfileNotExist Exception
+            }
+        } catch (EBaseException e) {
+            e.printStackTrace();
+            // throw internal error exception
+        }
+
+        changeProfileData(data, profile);
+    }
+
+    private void changeProfileData(ProfileData data, IProfile profile) {
+        String profileId = data.getId();
+        if (profile == null) {
+            // throw internal error exception
+        }
+        if (ps.isProfileEnable(profileId)) {
+            // throw bad request - profile must be disabled
+        }
+
+        Map<String, String> auditParams = new LinkedHashMap<String, String>();
+
+        if (differs(profile.getAuthenticatorId(), data.getAuthenticatorId())) {
+            profile.setAuthenticatorId(data.getAuthenticatorId());
+            auditParams.put("authenticatorId", data.getAuthenticatorId());
+        }
+
+        if (differs(profile.getAuthzAcl(),data.getAuthzAcl())) {
+            profile.setAuthzAcl(data.getAuthzAcl());
+            auditParams.put("authzAcl", data.getAuthzAcl());
+        }
+
+        if (differs(profile.getDescription(getLocale()), data.getDescription())) {
+            profile.setDescription(getLocale(), data.getDescription());
+            auditParams.put("description", data.getDescription());
+        }
+
+        if (differs(profile.getId(),data.getId())) {
+            profile.setId(data.getId());
+            auditParams.put("id", data.getId());
+        }
+
+        if (differs(profile.getName(getLocale()),data.getName())) {
+            profile.setName(getLocale(),data.getName());
+            auditParams.put("name", data.getName());
+        }
+
+        // TODO renewal is a string in Profile, should be changed
+        if (differs(profile.isRenewal(),Boolean.toString(data.isRenewal()))) {
+            profile.setRenewal(data.isRenewal());
+            auditParams.put("renewal", Boolean.toString(data.isRenewal()));
+        }
+
+        if (! profile.isVisible() == data.isVisible()) {
+            profile.setVisible(data.isVisible());
+            auditParams.put("visible", Boolean.toString(data.isVisible()));
+        }
+
+        // TODO xmloutput is a string in Profile, should be changed
+        if (differs(profile.isXmlOutput(),Boolean.toString(data.isXMLOutput()))) {
+            profile.setXMLOutput(data.isXMLOutput());
+            auditParams.put("xmloutput", Boolean.toString(data.isXMLOutput()));
+        }
+
+        // add audit log for auditParams
+
+        try {
+            populateProfileInputs(data, profile);
+
+            // add audit log for profile inputs
+
+            populateProfileOutputs(data, profile);
+
+            // add audit log for profile outputs
+
+            populateProfilePolicies(data, profile);
+
+            // add audit log for profile policies
+
+            profile.getConfigStore().commit(false);
+        } catch (EPropertyException e) {
+            e.printStackTrace();
+            // throw bad request exception
+        } catch (EBaseException e) {
+            e.printStackTrace();
+            // throw internal error exception
+        }
+    }
+
+    private boolean differs(String v1, String v2) {
+        if (v1 != null) {
+            if (!v1.equals(v2)) {
+                return true;
+            }
+        } else {
+            if (v2 != null) {
+                return true;
+            }
+        }
+        return false;
+    }
+
+    private void populateProfilePolicies(ProfileData data, IProfile profile) throws EProfileException, EPropertyException {
+        profile.deleteAllProfilePolicies();
+        for (Map.Entry<String,List<ProfilePolicy>> policySet:
+            data.getPolicySets().entrySet()) {
+            String setId = policySet.getKey();
+            for (ProfilePolicy policy: policySet.getValue()) {
+                PolicyDefault def = policy.getDef();
+                PolicyConstraint con = policy.getConstraint();
+
+                // create policy using defaults for PolicyDefault and PolicyConstraint
+                IProfilePolicy p = profile.createProfilePolicy(setId, policy.getId(),
+                        def.getClassId(), con.getClassId());
+
+                // change specific elements to match incoming data for PolicyDefault
+                IConfigStore pstore = profile.getConfigStore().getSubStore(
+                        "policyset." + setId + "." + policy.getId());
+                if (!def.getName().isEmpty()) {
+                    pstore.putString("default.name", def.getName());
+                }
+                /*if (!def.getText().isEmpty()) {
+                    pstore.putString("default.description", def.getText());
+                }*/
+                for (ProfileParameter param: def.getParams()) {
+                    if (!param.getValue().isEmpty()) {
+                        p.getDefault().setConfig(param.getName(), param.getValue());
+                    }
+                }
+
+                // change specific elements to match incoming data for PolicyConstraint
+                if (!con.getName().isEmpty()) {
+                    pstore.putString("constraint.name", con.getName());
+                }
+                /*if (!con.getText().isEmpty()) {
+                    pstore.putString("constraint.description", con.getText());
+                }*/
+                for (PolicyConstraintValue pcv : con.getConstraints()) {
+                    if (!pcv.getValue().isEmpty()) {
+                        p.getConstraint().setConfig(pcv.getName(), pcv.getValue());
+                    }
+                }
+            }
+        }
+    }
+
+    private void populateProfileOutputs(ProfileData data, IProfile profile) throws EProfileException {
+        profile.deleteAllProfileOutputs();
+        Map<String, ProfileOutput> outputs = data.getOutputs();
+        for (Entry<String, ProfileOutput> entry: outputs.entrySet()) {
+            String id = entry.getKey();
+            String classId = entry.getValue().getClassId();
+
+            NameValuePairs nvp = new NameValuePairs();
+            // TODO - add a field for params in ProfileOuput
+            // No current examples
+            profile.createProfileOutput(id, classId, nvp);
+        }
+    }
+
+    private void populateProfileInputs(ProfileData data, IProfile profile) throws EProfileException {
+        profile.deleteAllProfileInputs();
+       Map<String, ProfileInput> inputs = data.getInputs();
+        for (Entry<String, ProfileInput> entry: inputs.entrySet()) {
+            String id = entry.getKey();
+            String classId = entry.getValue().getClassId();
+
+            NameValuePairs nvp = new NameValuePairs();
+            // TODO - add a field for params in ProfileInput.
+            // an example of this is DomainController.cfg
+            profile.createProfileInput(id, classId, nvp);
+        }
+    }
+
+    public void deleteProfile(@PathParam("id") String profileId) {
+        if (ps == null) {
+            // throw internal error exception;
+        }
+
+        try {
+            IProfile profile = ps.getProfile(profileId);
+            if (profile == null) {
+                // log already deleted
+                return;
+            }
+
+            if (ps.isProfileEnable(profileId)) {
+                // log attempt to delete profile when enabled
+                // throw unauthorized exception
+            }
+
+            String configFile = CMS.getConfigStore().getString("profile." + profileId + ".config");
+
+            ps.deleteProfile(profileId, configFile);
+        } catch (EBaseException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+
+
+    }
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java b/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
index 50095b173c5b9a4d43c320cc5e81b9dcc25555c2..ae93320f9c31fa34c8550c4e982f11e496cc6343 100644
--- a/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
@@ -39,6 +39,7 @@ import com.netscape.cmstools.cert.CertCLI;
 import com.netscape.cmstools.client.ClientCLI;
 import com.netscape.cmstools.group.GroupCLI;
 import com.netscape.cmstools.key.KeyCLI;
+import com.netscape.cmstools.profile.ProfileCLI;
 import com.netscape.cmstools.system.KRAConnectorCLI;
 import com.netscape.cmstools.system.SecurityDomainCLI;
 import com.netscape.cmstools.user.UserCLI;
@@ -69,6 +70,7 @@ public class MainCLI extends CLI {
         addModule(new GroupCLI(this));
         addModule(new KeyCLI(this));
         addModule(new KRAConnectorCLI(this));
+        addModule(new ProfileCLI(this));
         addModule(new SecurityDomainCLI(this));
         addModule(new UserCLI(this));
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..2c30fdbd7cb693d556600061abc712acdc2439ba
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
@@ -0,0 +1,60 @@
+package com.netscape.cmstools.profile;
+
+import java.io.FileNotFoundException;
+
+import javax.xml.bind.JAXBException;
+
+import org.apache.commons.cli.CommandLine;
+import org.apache.commons.cli.ParseException;
+
+import com.netscape.certsrv.profile.ProfileData;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileAddCLI extends CLI {
+    public ProfileCLI parent;
+
+    public ProfileAddCLI(ProfileCLI parent) {
+        super("add", "Add profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <file>", options);
+    }
+
+    public void execute(String[] args) {
+        CommandLine cmd = null;
+
+        try {
+            cmd = parser.parse(options, args);
+        } catch (ParseException e) {
+            System.err.println("Error: " + e.getMessage());
+            printHelp();
+            System.exit(-1);
+        }
+
+        String[] cLineArgs = cmd.getArgs();
+
+        if (cLineArgs.length < 1) {
+            System.err.println("Error: No filename specified.");
+            printHelp();
+            System.exit(-1);
+        }
+        String filename = cLineArgs[0];
+        if (filename == null || filename.trim().length() == 0) {
+            System.err.println("Error: Missing input file name.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        try {
+            ProfileData data = ProfileCLI.readProfileFromFile(filename);
+            parent.client.createProfile(data);
+            MainCLI.printMessage("Added profile " + data.getId());
+        } catch (FileNotFoundException | JAXBException  e) {
+            System.err.println("Error: " + e.getMessage());
+            System.exit(-1);
+        }
+    }
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..37b88bcb5c654c93d2e1b0a2fb353e8d1b556df6
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
@@ -0,0 +1,118 @@
+package com.netscape.cmstools.profile;
+
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.util.Arrays;
+
+import javax.xml.bind.JAXBContext;
+import javax.xml.bind.JAXBException;
+import javax.xml.bind.Marshaller;
+import javax.xml.bind.Unmarshaller;
+
+import org.apache.commons.lang.StringUtils;
+
+import com.netscape.certsrv.profile.ProfileClient;
+import com.netscape.certsrv.profile.ProfileData;
+import com.netscape.certsrv.profile.ProfileDataInfo;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileCLI extends CLI {
+    public MainCLI parent;
+    public ProfileClient client;
+
+    public ProfileCLI(MainCLI parent) {
+        super("profile", "Profile management commands");
+        this.parent = parent;
+
+        addModule(new ProfileFindCLI(this));
+        addModule(new ProfileShowCLI(this));
+        addModule(new ProfileAddCLI(this));
+        addModule(new ProfileModifyCLI(this));
+        addModule(new ProfileRemoveCLI(this));
+        addModule(new ProfileEnableCLI(this));
+        addModule(new ProfileDisableCLI(this));
+    }
+
+    public void printHelp() {
+
+        System.out.println("Commands:");
+
+        int leftPadding = 1;
+        int rightPadding = 25;
+
+        for (CLI module : modules.values()) {
+            String label = name + "-" + module.getName();
+
+            int padding = rightPadding - leftPadding - label.length();
+            if (padding < 1)
+                padding = 1;
+
+            System.out.print(StringUtils.repeat(" ", leftPadding));
+            System.out.print(label);
+            System.out.print(StringUtils.repeat(" ", padding));
+            System.out.println(module.getDescription());
+        }
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        client = new ProfileClient(parent.client);
+
+        if (args.length == 0) {
+            printHelp();
+            System.exit(1);
+        }
+
+        String command = args[0];
+        String[] commandArgs = Arrays.copyOfRange(args, 1, args.length);
+
+        if (command == null) {
+            printHelp();
+            System.exit(1);
+        }
+
+        CLI module = getModule(command);
+        if (module != null) {
+            module.execute(commandArgs);
+
+        } else {
+            System.err.println("Error: Invalid command \"" + command + "\"");
+            printHelp();
+            System.exit(1);
+        }
+    }
+
+    public static void printProfileDataInfo(ProfileDataInfo info) {
+        System.out.println("Profile ID:  " + info.getProfileId());
+        System.out.println("Profile URL: " + info.getProfileURL());
+    }
+
+    public static void printProfile(ProfileData profileData) {
+        // TODO Auto-generated method stub
+
+    }
+
+    public static void saveProfileToFile(String filename, ProfileData data)
+            throws JAXBException, FileNotFoundException {
+        JAXBContext context = JAXBContext.newInstance(ProfileData.class);
+        Marshaller marshaller = context.createMarshaller();
+        marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
+
+        FileOutputStream stream = new FileOutputStream(filename);
+        marshaller.marshal(data, stream);
+
+        MainCLI.printMessage("Saved profile " + data.getId() + " to " + filename);
+    }
+
+    public static ProfileData readProfileFromFile(String filename)
+            throws JAXBException, FileNotFoundException {
+        ProfileData data = null;
+        JAXBContext context = JAXBContext.newInstance(ProfileData.class);
+        Unmarshaller unmarshaller = context.createUnmarshaller();
+        FileInputStream fis = new FileInputStream(filename);
+        data = (ProfileData) unmarshaller.unmarshal(fis);
+        return data;
+    }
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..0279cf36a879accd885c6aa3834f9e89fe8e71c1
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
@@ -0,0 +1,34 @@
+package com.netscape.cmstools.profile;
+
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileDisableCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileDisableCLI(ProfileCLI parent) {
+        super("disable", "Disable profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        if (args.length != 1) {
+            printHelp();
+            System.exit(1);
+        }
+
+        String profileId = args[0];
+
+        parent.client.disableProfile(profileId);
+
+        MainCLI.printMessage("Disabled profile \"" + profileId + "\"");
+    }
+
+
+}
